/*
1. according to my calculations, these are the paramaters of: 
   GSETPAL( nColor, nRed, nGreen, nBlue)
where,
	0 <= nColor <= 15 in increments of 1
	0 <= nRed <= 252 in increments of 4
	0 <= nGreen <= 252 in increments of 4
	0 <= nBlue <= 252 in increments of 4
(according to norton guides:
	0 <= nRed <= 63
	0 <= nGreen <= 63
	0 <= nBlue <= 63   )

2. SCROLLBAR doesn't behave very well. 
	3074	3076	3073	3077	3075
	Left            thumb           Right

	:update does not work at all.
	:hitTest does not recognize thumb past position 1
	:hitTest only recognizes half of the left and right buttons!
Another problem with the scrollbar is when you hold the left or right
button down, the thumb slides even when you release the mouse button.

3. Once the scrollbar is fixed by CA, I would like to use this function to
   allow my end-users to customize their colors. Even give them the option
   to create their own color-schemes and save the information in an ini file.

4. Any suggestions welcome.

by Pance Stojkovski, Toronto, Canada.
CIS 75061,3233		Internet: pance@sympatico.ca
*/
#include "inkey.ch"
#include "button.ch"
#include "llibg.ch"

STATIC nRed   := 0
STATIC nGreen := 0
STATIC nBlue  := 0
STATIC nColor
FUNCTION Main()
LOCAL nKey
LOCAL oScrollRed   := ScrollBar( 30, 51, 20, , 2) 
LOCAL oScrollGreen := ScrollBar( 30, 51, 22, , 2) 
LOCAL oScrollBlue  := ScrollBar( 30, 51, 24, , 2) 
MEMVAR lMouse
PUBLIC lMouse

SETCURSOR( 0)
SET VIDEOMODE TO LLG_VIDEO_VGA_640_480_16
   // Make the mouse cursor visible if mouse driver is loaded
IF MPRESENT()
   lMouse := .T.
   MDBLCLK( 400 )
   SET( _SET_EVENTMASK, INKEY_ALL )
   MSETPOS( 23,15 )
   MSETCURSOR( .T.)
   MSHOW( LLM_CURSOR_WAIT)
 ELSE
   @ 10, 10 SAY "Mouse is not available."
   lMouse := .F.
   SET( _SET_EVENTMASK, INKEY_KEYBOARD )
ENDIF

FOR nColor := 0 TO 7
   GRECT( nColor*80+5, 64+5, (nColor+1)*80-5, 160-5, LLG_FILL, nColor, LLG_MODE_SET)
NEXT
FOR nColor := 8 TO 15
   GRECT( (nColor-8)*80+5, 192+5, (nColor-8+1)*80-5, 288-5, LLG_FILL, nColor, LLG_MODE_SET)
NEXT

nColor := 0
oScrollRed:total := 253
oScrollGreen:total := 253
oScrollBlue:total := 253

@ 19, 0 SAY "0123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789"
@ 20, 25 SAY "red"
@ 20, 53 SAY "RED"
@ 22, 23 SAY "green"
@ 22, 53 SAY "GREEN"
@ 24, 24 SAY "blue"
@ 24, 53 SAY "BLUE"
@ 26, 1 SAY REPLICATE("-", 78)
@ 26, 5 SAY " Only the red scroll bar is mouse aware. "
MSHOW( LLM_CURSOR_ARROW)
DO WHILE .T.
   PaintBox( nColor)
   GSETPAL( nColor, nRed, nGreen, nBlue)
   oScrollRed:current := nRed
   oScrollRed:thumbPos := (nRed*(oScrollRed:barlength-2))/oScrollRed:total
   oScrollRed:display() 
   oScrollGreen:thumbPos := (nGreen*(oScrollGreen:barlength-2))/oScrollGreen:total
   oScrollGreen:display() 
   oScrollBlue:thumbPos := (nBlue*(oScrollBlue:barlength-2))/oScrollBlue:total
   oScrollBlue:display() 
   @ 20, 10 SAY GSETPAL(nColor)[1]
   @ 22, 10 SAY GSETPAL(nColor)[2]
   @ 24, 10 SAY GSETPAL(nColor)[3]
   CLEAR TYPEAHEAD
   nKey := INKEY(0, INKEY_KEYBOARD + INKEY_LDOWN)
   @ 27, 10 SAY "nKey: "+STR(nKey, 8, 2)
   @ 28, 10 SAY "HitTest: "+STR(oScrollRed:HitTest( MROW(), MCOL()), 8, 2)
   @ 28, 40 SAY "BarLength: "+STR(oScrollRed:barlength,8,2)
   @ 29, 10 SAY "ThumbPos: "+STR(oScrollRed:thumbPos,8,2)
   DO CASE
      CASE nKey == ASC("R")
         IIF( nRed < 249, nRed += 4, nRed := 0)
      CASE nKey == ASC("r")
         IIF( nRed > 3, nRed -= 4, nRed := 252)
      CASE nKey == ASC("G")
         IIF( nGreen < 249, nGreen += 4, nGreen := 0)
      CASE nKey == ASC("g")
         IIF( nGreen > 3, nGreen -= 4, nGreen := 252)
      CASE nKey == ASC("B")
         IIF( nBlue < 249, nBlue += 4, nBlue := 0)
      CASE nKey == ASC("b")
         IIF( nBlue > 3, nBlue -= 4, nBlue := 252)
      CASE nKey == K_UP
         DelBox( nColor)
         IIF(nColor > 7, nColor -= 8, nColor += 8)
         MoveCol()
      CASE nKey == K_DOWN
         DelBox( nColor)
         IIF(nColor < 8, nColor += 8, nColor -= 8)
         MoveCol()
      CASE nKey == K_RIGHT
         DelBox( nColor)
         IIF(nColor == 15, nColor := 0, nColor++)
         MoveCol()
      CASE nKey == K_LEFT
         DelBox( nColor)
         IIF(nColor == 0, nColor := 15, nColor--)
         MoveCol()
      CASE nKey == K_LBUTTONDOWN .AND. oScrollRed:HitTest( MROW(), MCOL()) == HTSCROLLUNITINC
         /* this loop is here to allow for quick updates while lbutton is down. 
            Unfortunately, sometimes even when lbutton is not down!?! */
         DO WHILE LASTKEY() == K_LBUTTONDOWN 
            IF nRed < 249
               nRed += 4
               oScrollRed:thumbPos += (4*(oScrollRed:barlength-3))/oScrollRed:total
              ELSE
               nRed := 0
               oScrollRed:thumbPos := 1.0
            ENDIF
            oScrollRed:display()
            GSETPAL( nColor, nRed, nGreen, nBlue)
            @ 20, 10 SAY GSETPAL(nColor)[1]
            INKEY(.1) 
         ENDDO
      CASE nKey == K_LBUTTONDOWN .AND. oScrollRed:HitTest( MROW(), MCOL()) == HTSCROLLUNITDEC
         DO WHILE LASTKEY() == K_LBUTTONDOWN
            IF nRed > 3
               nRed -= 4
               oScrollRed:thumbPos -= (4*(oScrollRed:barlength-3))/oScrollRed:total
              ELSE
               nRed := 252
               oScrollRed:thumbPos := 19
            ENDIF
            oScrollRed:display()
            GSETPAL( nColor, nRed, nGreen, nBlue)
            @ 20, 10 SAY GSETPAL(nColor)[1]
            INKEY(.1) 
         ENDDO
      CASE nKey == K_LBUTTONDOWN .AND. MROW() > 3 .AND. MROW() < 11
         DelBox( nColor)
         nColor := INT( MCOL()/10)
         MoveCol()
      CASE nKey == K_LBUTTONDOWN .AND. MROW() > 11 .AND. MROW() < 19
         DelBox( nColor)
         nColor := INT( MCOL()/10) + 8
         MoveCol()
      CASE nKey == K_ESC
         EXIT
   ENDCASE
ENDDO

RETURN nil

/*-----------------*/
STATIC FUNCTION MoveCol
nRed   := GSETPAL( nColor)[1]
nGreen := GSETPAL( nColor)[2]
nBlue  := GSETPAL( nColor)[3]
RETURN nil

/*-----------------*/
FUNCTION PaintBox( nColor)
IF nColor < 8
   GRECT(  nColor*80,      64,   (nColor+1)*80, 64+5, LLG_FILL, 12, LLG_MODE_SET)
   GRECT(  nColor*80,    160-5,  (nColor+1)*80,  160, LLG_FILL, 12, LLG_MODE_SET)
   GRECT(  nColor*80,     64,     nColor*80+5, 160-5, LLG_FILL, 12, LLG_MODE_SET)
   GRECT( (nColor+1)*80-5, 64,  (nColor+1)*80,   160, LLG_FILL, 12, LLG_MODE_SET)
 ELSE
   GRECT( (nColor-8)*80,    192, (nColor-8+1)*80, 192+5, LLG_FILL, 12, LLG_MODE_SET)
   GRECT( (nColor-8)*80,   288-5,(nColor-8+1)*80, 288,   LLG_FILL, 12, LLG_MODE_SET)
   GRECT( (nColor-8)*80,    192, (nColor-8)*80+5, 288-5, LLG_FILL, 12, LLG_MODE_SET)
   GRECT( (nColor-8+1)*80-5,192, (nColor-8+1)*80, 288,   LLG_FILL, 12, LLG_MODE_SET)
ENDIF
RETURN nil

/*-----------------*/
FUNCTION DelBox( nColor)
IF nColor < 8
   GRECT(  nColor*80,     64,   (nColor+1)*80, 64+5, LLG_FILL, 0, LLG_MODE_SET)
   GRECT(  nColor*80,    160-5,  (nColor+1)*80,  160, LLG_FILL, 0, LLG_MODE_SET)
   GRECT(  nColor*80,    64+6,    nColor*80+5, 160-6, LLG_FILL, 0, LLG_MODE_SET)
   GRECT( (nColor+1)*80-5, 64+6, (nColor+1)*80, 160-6, LLG_FILL, 0, LLG_MODE_SET)
 ELSE
   GRECT( (nColor-8)*80,    192,   (nColor-8+1)*80, 192+5, LLG_FILL, 0, LLG_MODE_SET)
   GRECT( (nColor-8)*80,   288-5,  (nColor-8+1)*80, 288,   LLG_FILL, 0, LLG_MODE_SET)
   GRECT( (nColor-8)*80,    192+6, (nColor-8)*80+5, 288-6, LLG_FILL, 0, LLG_MODE_SET)
   GRECT( (nColor-8+1)*80-5,192+6, (nColor-8+1)*80, 288-6, LLG_FILL, 0, LLG_MODE_SET)
ENDIF
RETURN nil

